"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = _interopRequireWildcard(require("react"));
var _react2 = require("@emotion/react");
var _RtkQueryInspector = _interopRequireDefault(require("./RtkQueryInspector"));
var _reducers = require("../reducers");
var _themes = require("../styles/themes");
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function (e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
class RtkQueryMonitor extends _react.Component {
  static update = _reducers.reducer;
  static defaultProps = {
    theme: 'nicinabox',
    invertTheme: false
  };
  render() {
    const {
      currentStateIndex,
      computedStates,
      monitorState,
      dispatch,
      actionsById,
      theme,
      invertTheme
    } = this.props;
    const base16Theme = (0, _themes.resolveBase16Theme)(theme);
    const styleUtils = {
      base16Theme,
      invertTheme
    };
    const rtkQueryMonitorTheme = (0, _themes.createRtkQueryMonitorThemeFromBase16Theme)(base16Theme, invertTheme);
    return (0, _react2.jsx)(_themes.StyleUtilsContext.Provider, {
      value: styleUtils
    }, (0, _react2.jsx)(_react2.ThemeProvider, {
      theme: rtkQueryMonitorTheme
    }, (0, _react2.jsx)(_RtkQueryInspector.default, {
      computedStates: computedStates,
      currentStateIndex: currentStateIndex,
      monitorState: monitorState,
      dispatch: dispatch,
      actionsById: actionsById
    })));
  }
}
var _default = exports.default = RtkQueryMonitor;